<template>
  <GI18nCard :card="card" :i18n="i18n" level="third" v-bind="$attrs">
    <template #card-title-append>
      <v-spacer />
      <GDropDownMenu
        i18n="form.addElement"
        :available-elements="availableElements"
        icon="add"
        color="theme--light"
        @addElement="addElement"
      />
    </template>
    <v-alert
      v-if="!atLeastOneIsFilled"
      class="mt-4"
      color="warning"
      icon="warning"
    >
      {{ $t("dcc.common.locationType.alert") }}
    </v-alert>
    <v-row dense>
      <GCol cols="12" md="4">
        <DccArrayWrapper
          v-model="value.postCode"
          :component="XmlTextField"
          i18n="dcc.common.locationType.postCode"
          :disabled="disabled"
          validate="notEmptyStringType"
        />
      </GCol>
      <GCol cols="12" md="8">
        <DccArrayWrapper
          v-model="value.city"
          :component="XmlTextField"
          i18n="dcc.common.locationType.city"
          :disabled="disabled"
          validate="notEmptyStringType"
        />
      </GCol>
      <GCol cols="12" md="8">
        <DccArrayWrapper
          v-model="value.street"
          :component="XmlTextField"
          i18n="dcc.common.locationType.street"
          :disabled="disabled"
          validate="notEmptyStringType"
        />
      </GCol>
      <GCol cols="12" md="4">
        <DccArrayWrapper
          v-model="value.streetNo"
          :component="XmlTextField"
          i18n="dcc.common.locationType.streetNo"
          :disabled="disabled"
          validate="notEmptyStringType"
        />
      </GCol>
      <GCol cols="12">
        <RichContent
          v-if="value.further && value.further[0]"
          ref="further"
          v-model="value.further[0]"
          i18n="dcc.common.locationType.further.title"
          optional
          not-in-dialog
          level="second"
          @delete="deleteRichContent"
        />
      </GCol>
      <GCol cols="6">
        <DccArrayWrapper
          v-model="value.state"
          :component="XmlTextField"
          i18n="dcc.common.locationType.state"
          :disabled="disabled"
          validate="notEmptyStringType"
        />
      </GCol>
      <GCol cols="6">
        <GAutocomplete
          v-model="countryCode"
          :items="countryCodes"
          :item-text="(item) => `${item.code} - ${item.name}`"
          item-value="code"
          i18n="dcc.common.locationType.countryCode"
          :disabled="disabled"
        />
      </GCol>
    </v-row>
  </GI18nCard>
</template>

<script>
import { DCCXMLElement, RichContentType } from "@d-ptb/dcc-js";
import GI18nCard from "../../App/Common/GI18nCard";
import XmlTextField from "../../App/Form/XML/XmlTextField";
import GAutocomplete from "../../App/Form/gAutocomplete";
import DccLocalizedTextarea from "../../App/Form/XML/DccLocalizedTextarea";
import RichContent from "../../DCC/Common/RichContent";
import { validatableMixin } from "~/components/Mixins/validatableMixin";
import ISO3611 from "~/assets/lists/iso-3611-codes";
import DccArrayWrapper from "~/components/App/Form/XML/DccArrayWrapper";
import GCol from "~/components/App/Common/GCol";
import GDropDownMenu from "~/components/App/Common/GDropDownMenu.vue";
import { insertIf } from "~/assets/util/general";

export default {
  name: "Location",
  components: {
    GDropDownMenu,
    GCol,
    DccArrayWrapper,
    GAutocomplete,
    GI18nCard,
    RichContent,
  },
  mixins: [validatableMixin],
  props: {
    value: Object,
    i18n: String,
    title: String,
    disabled: Boolean,
    card: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      countryCodes: ISO3611,
      XmlTextField,
      DccLocalizedTextarea,
      RichContent,
    };
  },
  computed: {
    atLeastOneIsFilled() {
      return !!(
        (this.value.postCode && this.value.postCode.length > 0) ||
        (this.value.city && this.value.city.length > 0) ||
        (this.value.street && this.value.street.length > 0) ||
        (this.value.streetNo && this.value.streetNo.length > 0) ||
        (this.value.further && this.value.further.length > 0) ||
        (this.value.state && this.value.state.length > 0) ||
        (this.value.countryCode && this.value.countryCode.length > 0)
      );
    },
    customRules() {
      return [() => this.atLeastOneIsFilled];
    },
    titleText() {
      return this.i18n ? this.$t(this.i18n) : this.title;
    },
    availableElements() {
      return ["further"]
        .filter((x) => !this.blacklist.includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.common.locationType.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    blacklist() {
      return [
        ...insertIf(this.value.further && this.value.further[0], "further"),
      ];
    },
    countryCode: {
      get() {
        return this.value.countryCode && this.value.countryCode[0]
          ? this.value.countryCode[0]._text
          : "";
      },
      set(val) {
        if (val) {
          this.value.countryCode = [new DCCXMLElement({ _text: val })];
        } else {
          this.value.countryCode = null;
        }
      },
    },
  },
  watch: {
    "value.postCode"() {
      this.validate();
    },
    "value.city"() {
      this.validate();
    },
    "value.street"() {
      this.validate();
    },
    "value.streetNo"() {
      this.validate();
    },
    "value.further"() {
      this.validate();
    },
    "value.state"() {
      this.validate();
    },
    "value.countryCode"() {
      this.validate();
    },
  },
  methods: {
    addRichContent() {
      this.$set(this.value, "further", [new RichContentType()]);
      // TODO: Workaround. Reactivity seems to be broken if used in Items or Statements
      this.$forceUpdate();
    },
    deleteRichContent() {
      confirm(this.$t("dcc.common.locationType.further.confirmRemove")) &&
        this.$delete(this.value, "further");
      // TODO: Workaround. Reactivity seems to be broken if used in Items or Statements
      this.$forceUpdate();
      this.$emit("deleteFurther");
    },
    addElement(element) {
      switch (element) {
        case "further":
          this.$set(this.value, "further", [new RichContentType()]);
      }
    },
  },
};
</script>
